﻿#NoEnv
SetWorkingDir %A_ScriptDir%
SetBatchLines -1

RegCOM("TesoSeeu.ocx.manifest")
global CamaOcx, g_nImgFmt := 1

Gui, Add, ActiveX, w500 h400 vCamaOcx, {7EEAA4B5-DE19-493F-950C-4053B77195D2}
Gui, Add, DDL, xm vDevIdx w200 gOpenCamera AltSubmit, 
Gui, Add, Button, x+50 gSavePhoto, Save Photo
Gui, Show
AddDevsToDDL()
Return

OpenCamera:
	if DevIdx
		CamaOcx.CloseCapDev(0)

	GuiControlGet, DevIdx
	CamaOcx.openCapDev(DevIdx, 0)
return

SavePhoto:
	hBuffer := CamaOcx.SnapOne(g_nImgFmt)
	nIsz := CamaOcx.GetImgLen(g_nImgFmt)

	; FileOpen("OneSnap.bmp", "w").RawWrite(hBuffer+0, nIsz)

	pToken := Gdip_Startup()
	pBitmap := GDIPlus_pBitmapFromhBuffer(hBuffer, nIsz)
	Gdip_SaveBitmapToFile(pBitmap, "OneSnap.jpg")
	Gdip_Shutdown(pToken)
return

AddDevsToDDL() {
	Loop % CamaOcx.GetDevCnt(0)
	{
		v .= CamaOcx.GetDevNam(A_Index) "|"
	}
	if v
	{
		GuiControl,, DevIdx, % "|" RegExReplace(v, "\|", "||",, 1)
		SetTimer, OpenCamera, -1
	}
}

GuiClose:
ExitApp

;GdiPlus_SaveImageToBuffer() - Scripts and Functions - AutoHotkey Community
;https://autohotkey.com/board/topic/85523-gdiplus-saveimagetobuffer/
GDIPlus_pBitmapFromhBuffer( ByRef hBuffer, nSize ) { ;  Last Modifed : 21-Jun-2011
	; Adapted version by SKAN www.autohotkey.com/forum/viewtopic.php?p=383863#383863
	; Original code   by Sean www.autohotkey.com/forum/viewtopic.php?p=147029#147029
	hData := DllCall("GlobalAlloc", UInt,2, UInt,nSize )
	pData := DllCall("GlobalLock",  UInt,hData )
	DllCall( "RtlMoveMemory", UInt,pData, UInt,hBuffer, UInt,nSize )
	DllCall( "GlobalUnlock" , UInt,hData )
	DllCall( "ole32\CreateStreamOnHGlobal", UInt,hData, Int,True, UIntP,pStream )
	DllCall( "gdiplus\GdipCreateBitmapFromStream",  UInt,pStream, UIntP,pBitmap )
	DllCall( NumGet( NumGet(1*pStream)+8 ), UInt,pStream ) ; IStream::Release
	Return pBitmap
}
